#include <bits/stdc++.h>

using namespace std;

const int maxn=1e3+10;
const int sigma = 27;

int n;

int cvor(int x,int y){
    return x*n+y;
}

int dsu[maxn*maxn];
int siz[maxn*maxn];
bitset<maxn*maxn> dobar;

int cale(int x){
    return (x==dsu[x] ? x:dsu[x]=cale(dsu[x]));
}

void join(int a,int b){
    a=cale(a);
    b=cale(b);
    if(a==b) return;
    if(siz[a]<siz[b]) swap(a,b);
    dsu[b]=a;
    siz[a]+=siz[b];
    dobar[a]=dobar[a]||dobar[b];
}

int boja[sigma][maxn];
vector<int> comp[sigma][maxn];
int gde[sigma][maxn];
bool ujebana[sigma][maxn];
vector<pair<int,int> > bitne[sigma];

void init(){
    for(int i=0;i<maxn*maxn;i++){
        dsu[i]=i;
        siz[i]=1;
        dobar[i]=false;
    }
    for(int i=0;i<n;i++){
        for(int j=0;j<n;j++){
            join(cvor(i,j),cvor(j,i));
        }
    }
    for(int i=0;i<n;i++){
        for(int j=0;j<sigma;j++){
            comp[j][i].push_back(i);
            gde[j][i]=i;
        }
    }
    for(int i=0;i<n;i++) dobar[cvor(i,i)]=true;
}

void spoji(int a,int b,int c){
    //bitne[c].push_back({a,b});
    if(gde[c][a]==gde[c][b]){
        if(boja[c][a]==boja[c][b] && !ujebana[c][gde[c][a]]){
            ujebana[c][gde[c][a]]=true;
            bitne[c].push_back({a,b});
        }
    }else{
        bitne[c].push_back({a,b});
        int dod=0;
        if(boja[c][a]==boja[c][b]){
            dod=1;
        }
        if(comp[c][gde[c][a]].size()<comp[c][gde[c][b]].size()){
            swap(comp[c][gde[c][a]],comp[c][gde[c][b]]);
        }
        ujebana[c][gde[c][a]] = ujebana[c][gde[c][b]] || ujebana[c][gde[c][a]];
        for(int i:comp[c][gde[c][b]]){
            comp[c][gde[c][a]].push_back(i);
            boja[c][i]=(boja[c][i]+dod)&1;
            gde[c][i]=gde[c][a];
        }
    }
}

void kurcina(int u,int v,int a,int b){
    join(cvor(u,a),cvor(v,b));
    join(cvor(u,b),cvor(v,a));
}

int main(){
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int q; cin>>n>>q;
    init();
    while(q--){
        int t; cin>>t;
        if(t==1){
            int u,v; char cc;
            cin>>u>>v>>cc; u--; v--;
            int c=cc-'a';
            dobar[cale(cvor(u,v))]=true;

            spoji(u,v,c);

            if(!bitne[c].empty() && bitne[c].back()==pair<int,int>(u,v)){
                for(int i=0;i<int(bitne[c].size())-1;i++){
                    kurcina(bitne[c][i].first,bitne[c][i].second,u,v);
                }
            }

        }else{
            int u,v; cin>>u>>v; u--; v--;
            cout<<int(dobar[cale(cvor(u,v))])<<"\n";
        }
    }
    return 0;
}